SystemOrganization addCategory: #'TP BichOS'!

Object subclass: #Alimento
	instanceVariableNames: 'masa posicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Alimento methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/18/2015 13:20'!
extraerComida: limite 
	| masaExtraida |
	masaExtraida := (limite  min: (masa-1) ).
	masa := masa - (masaExtraida + 1).
	^ 0 max: masaExtraida.
 
			! !

!Alimento methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 15:39'!
masa
	^ masa! !

!Alimento methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 15:39'!
masa: anObject
	masa := anObject! !

!Alimento methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 17:21'!
posicion
^ posicion
! !

!Alimento methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 17:21'!
posicion: unPunto
posicion:= unPunto! !

Object subclass: #Cansada
	instanceVariableNames: 'normal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 16:00'!
cambiarEstado: unaHormiga
unaHormiga estado: normal.! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 17:43'!
descansar: unaHormiga
	self cambiarEstado: unaHormiga.
	! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:05'!
extraerComidaDe: unAlimento con: unaHormiga! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:38'!
irA: unPunto con: unaHormiga
! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:37'!
llevarAlimentoA: unHormiguero con: unaHormiga
! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:26'!
normal
^normal! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:26'!
normal: unEstado
normal:= unEstado
! !

Object subclass: #Exaltada
	instanceVariableNames: 'normal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:59'!
cambiarEstado: unaHormiga
unaHormiga estado: normal.! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:32'!
descansar: unaHormiga! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:08'!
extraerComidaDe: unAlimento con: unaHormiga
	unaHormiga extraerComidaExaltadaDe: unAlimento.! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 16:00'!
irA: unPunto con: unaHormiga
unaHormiga irAExaltada: unPunto.
! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:37'!
llevarAlimentoA: unHormiguero con: unaHormiga
	unaHormiga llevarAlimentoANormal: unHormiguero! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:27'!
normal
^normal
! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:26'!
normal: unEstado
normal:= unEstado
! !

Object subclass: #Hormiga
	instanceVariableNames: 'pesollevado distanciaRecorrida posicion puntosRecorridos estado distanciaRecorridaNpuntos posicionDos pesoLlevado cansada distanciaRecorridaParaCansancio distanciaRecorridaExaltada distanciaRecorridaParaCansancioOExaltada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/19/2015 11:26'!
descansar
	estado descansar: self.
	! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:40'!
distanciaRecorrida
	^ distanciaRecorrida! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:41'!
distanciaRecorrida: anObject
	distanciaRecorrida := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 13:38'!
distanciaRecorridaNpuntos
	  ^distanciaRecorridaNpuntos.! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/19/2015 15:13'!
distanciaRecorridaNpuntos: unaCantidad
distanciaRecorridaNpuntos:= unaCantidad.
! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/19/2015 17:44'!
distanciaRecorridaParaCansancioOExaltada
	^distanciaRecorridaParaCansancioOExaltada! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/19/2015 17:44'!
distanciaRecorridaParaCansancioOExaltada: unaCantidad
distanciaRecorridaParaCansancioOExaltada:= unaCantidad.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/16/2015 15:59'!
distanciaRecorridaPromedio
	^ distanciaRecorrida / (puntosRecorridos size)! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:31'!
distanciaRecorridaPromedioUltimosNPuntos: unaCantidad
	^ (self distanciaRecorridaUltimosNPuntos:unaCantidad ) / unaCantidad! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/19/2015 14:55'!
distanciaRecorridaUltimosNPuntos: unaCantidad 

self distanciaRecorridaNpuntos:0.
self posicionDos: (self ultimosNPuntos:unaCantidad )first.

((self ultimosNPuntos: unaCantidad )allButFirst) do: [ :punto | self irAdeNpuntos: punto ].
^self distanciaRecorridaNpuntos.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/15/2015 16:16'!
estaAlLimite
	^ pesollevado >= 9! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/19/2015 15:19'!
estaCansada
	^estado class = Cansada.! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 16:38'!
estado
	^ estado! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 16:38'!
estado: anObject
	estado := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:27'!
extraerComidaDe: unAlimento
	estado extraerComidaDe: unAlimento con: self ! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:08'!
extraerComidaExaltadaDe: unAlimento
      self irA:  unAlimento posicion.
	self pesollevado: pesollevado + (unAlimento extraerComida: (self limiteDeCargaDisponible)+10).
	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:03'!
extraerComidaNormalDe: unAlimento 
	self irA:  unAlimento posicion.
	self pesollevado: pesollevado + (unAlimento extraerComida: self limiteDeCargaDisponible).
	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 17:45'!
initialize
	distanciaRecorrida := 0.
	self distanciaRecorridaParaCansancioOExaltada: 0.
	self pesollevado: 0.
	self puntosRecorridos: OrderedCollection new.
	estado := Normal new.
	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:29'!
irA: unPunto
	estado irA:unPunto con: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 17:46'!
irAExaltada:unPunto
	self distanciaRecorrida: ((self distanciaRecorrida) +((self posicion )distanciaA: unPunto)).
	self distanciaRecorridaParaCansancioOExaltada:  self distanciaRecorridaParaCansancioOExaltada   + ((self posicion )distanciaA: unPunto).
	self posicion: unPunto.
	(self puntosRecorridos) add: unPunto.
	(self distanciaRecorridaParaCansancioOExaltada>5) ifTrue: [self estado cambiarEstado:self ]! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 17:45'!
irANormal:unPunto
	self distanciaRecorrida: ((self distanciaRecorrida) +((self posicion )distanciaA: unPunto)).
	self distanciaRecorridaParaCansancioOExaltada: self distanciaRecorridaParaCansancioOExaltada   + ((self posicion )distanciaA: unPunto).
	self posicion: unPunto.
	(self puntosRecorridos) add: unPunto.
	(self distanciaRecorridaParaCansancioOExaltada  >10) ifTrue: [self estado cambiarEstado:self ]! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/17/2015 14:04'!
irAdeNpuntos: unPunto
	self distanciaRecorridaNpuntos: ((self distanciaRecorridaNpuntos) +((self posicionDos )distanciaA: unPunto)).
	self posicionDos: unPunto.! !

!Hormiga methodsFor: 'accessing' stamp: 'GonzaloRiggi 9/18/2015 13:26'!
limiteDeCargaDisponible
^10-pesollevado! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:35'!
llevarAlimentoA: unHormiguero
	estado llevarAlimentoA: unHormiguero con: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 16:24'!
llevarAlimentoANormal: unHormiguero
	
	unHormiguero aumentarDeposito: self pesollevado.
	self pesollevado: 0.
	self irA: (unHormiguero posicion). ! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:16'!
pesollevado
	^ pesollevado! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:16'!
pesollevado: anObject
	pesollevado := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:39'!
posicion
	^ posicion! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:39'!
posicion: anObject
	posicion := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 14:05'!
posicionDos
	^ posicionDos! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 14:05'!
posicionDos: anObject
	posicionDos := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:44'!
puntosRecorridos
	^ puntosRecorridos! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:44'!
puntosRecorridos: anObject
	puntosRecorridos := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/19/2015 10:31'!
ultimosNPuntos: unaCantidad 
^( self puntosRecorridos) copyFrom:  (self puntosRecorridos size)- unaCantidad to: ( self puntosRecorridos size)! !

Object subclass: #Hormiguero
	instanceVariableNames: 'hormigas deposito posicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Hormiguero methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/16/2015 16:17'!
agregarHormiga: unaHormiga

(self hormigas) add: unaHormiga.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:23'!
alimentoRecolectado
	^ hormigas sum: [: hormiga | hormiga pesollevado]! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:37'!
alimentoTotal
	^ deposito + self alimentoRecolectado! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:51'!
aumentarDeposito: unaCantidad
	self deposito: deposito + unaCantidad ! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/16/2015 16:13'!
cantidadDeHormigas
	^ hormigas size! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
deposito
	^ deposito! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
deposito: anObject
	deposito := anObject! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
hormigas
	^ hormigas! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
hormigas: anObject
	hormigas := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:25'!
hormigasAlLimite
	^ (hormigas select: [: hormiga | hormiga estaAlLimite]) length! !

!Hormiguero methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 15:52'!
initialize
self hormigas: Bag new.
deposito:=0.
! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:47'!
posicion
	^ posicion! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:47'!
posicion: anObject
	posicion := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:50'!
reclamarAlimento
	hormigas do: [: hormiga | hormiga llevarAlimentoA: self].! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/17/2015 16:12'!
recorridoTotalHormigas
^self hormigas sum: [ :hormiga | hormiga distanciaRecorrida  ]! !

Object subclass: #Normal
	instanceVariableNames: 'exaltada cansada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Normal methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 17:56'!
cambiarEstado: unaHormiga
	unaHormiga estado: cansada.
	unaHormiga distanciaRecorridaParaCansancioOExaltada:  0.
	
! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 17:47'!
descansar: unaHormiga
	unaHormiga estado: exaltada.
	unaHormiga distanciaRecorridaParaCansancioOExaltada:0.
	
! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:06'!
extraerComidaDe: unAlimento con: unaHormiga
	unaHormiga extraerComidaNormalDe: unAlimento.
	! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:23'!
initialize
cansada := Cansada new.
cansada normal: self.
exaltada := Exaltada new.
exaltada normal: self.! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:30'!
irA:unPunto con: unaHormiga
	unaHormiga irANormal: unPunto.! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:37'!
llevarAlimentoA: unHormiguero con: unaHormiga
	unaHormiga llevarAlimentoANormal: unHormiguero! !

Object subclass: #Punto
	instanceVariableNames: 'latitud longitud'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Punto methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/16/2015 13:51'!
distanciaA: otroPunto
	^(((latitud-otroPunto latitud)**2)+ ((longitud - otroPunto longitud) **2 ))sqrt.
! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
latitud
	^ latitud! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
latitud: anObject
	latitud := anObject! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
longitud
	^ longitud! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
longitud: anObject
	longitud := anObject! !
